
#include <iostream>
#include <iomanip>
#include <initializer_list>
#include <limits>
#include <cmath>
#include <fstream>

using std::cout;
using std::setw;
using std::showpos;
using std::noshowpos;
using std::initializer_list;
using std::ostream;
using std::ofstream;

using big_int = signed long long int;

constexpr int dbl_prec {6};
constexpr int dbl_wid {11};

#include "misc.h"

#include "cid_A.h"
#include "cid_B.h"
#include "cid_C.h"
#include "cid_D.h"

#include "demo_1.h"
#include "demo_2.h"
#include "demo_3.h"
#include "demo_4.h"
#include "demo_5.h"

// #include "test.h"

int main () {
    cout.setf (std::ios::fixed, std::ios::floatfield);
    cout.precision (dbl_prec);

    if (true) {
        demo_1::ctor_1 ();
        demo_1::ctor_2 ();
        demo_1::ctor_3 ();
        demo_1::ctor_4 ();
        demo_1::single ();
    }

    if (true) {
        demo_2::pos_neg ();
        demo_2::add ();
        demo_2::sub ();
    }

    if (true) {
        demo_3::mul ();
        demo_3::div ();
        demo_4::dot ();
    }

    if (true) {
        demo_5::mix_order_add ();
        demo_5::mix_order_sub ();
        demo_5::mix_order_mul ();
        demo_5::mix_order_div ();
        demo_5::mix_step ();
    }
    
    cos_int_dom<9,big_int,1>::mul_table ();



    cout << "\n\n";
    return 0;
}
